--- linux-linaro-3.4-2012.05-1_original/sound/soc/celestial/codec-hdmi-i2s.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/sound/soc/celestial/codec-hdmi-i2s.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,90 @@
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <linux/io.h>
+
+#include <sound/soc.h>
+#include <sound/tlv.h>
+
+struct cnc_hdmi_data {
+	void __iomem *mmio;
+};
+
+static int cnc_hdmi_i2s_hw_params(struct snd_pcm_substream *substream,
+				 struct snd_pcm_hw_params *params, struct snd_soc_dai *dai)
+{
+//	int rate = params_rate(params);
+	return 0;
+}
+
+static struct snd_soc_dai_ops dai_i2s_ops = {
+	.hw_params = cnc_hdmi_i2s_hw_params,
+};
+
+static struct snd_soc_dai_driver snd_codec_i2s_dai = {
+	.name = "hdmi-i2s-hifi",
+	.playback = {
+		.stream_name = "Playback",
+		.channels_min = 1,
+		.channels_max = 8,
+		.rates = SNDRV_PCM_RATE_8000_192000,
+		.formats = SNDRV_PCM_FMTBIT_S16 | SNDRV_PCM_FMTBIT_S24_3LE,
+	},
+	.ops = &dai_i2s_ops,
+};
+
+static int cnc_hdmi_probe(struct snd_soc_codec *codec)
+{
+	return 0;
+}
+
+static const struct snd_kcontrol_new cnc_hdmi_controls[] = {
+};
+
+static struct snd_soc_codec_driver soc_codec_hdmi = {
+	.probe	= cnc_hdmi_probe,
+	.controls = cnc_hdmi_controls,
+	.num_controls = ARRAY_SIZE(cnc_hdmi_controls),
+};
+
+static int __devinit hdmi_i2s_probe(struct platform_device *pdev)
+{
+	struct cnc_hdmi_data *data;
+	struct resource *iores;
+
+	data = kzalloc(sizeof(struct cnc_hdmi_data), GFP_KERNEL);
+	if (!data)
+		return -ENOMEM;
+
+	iores = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+	if (!iores)
+		return -ENODEV;
+
+	data->mmio = ioremap(iores->start, resource_size(iores));
+	if (!data->mmio)
+		return -EBUSY;
+
+	platform_set_drvdata(pdev, data);
+
+	return snd_soc_register_codec(&pdev->dev,
+			&soc_codec_hdmi, &snd_codec_i2s_dai, 1);
+}
+
+static int __devexit hdmi_i2s_remove(struct platform_device *pdev)
+{
+	snd_soc_unregister_codec(&pdev->dev);
+	return 0;
+}
+
+static struct platform_driver codec_hdmi_i2s_driver = {
+	.driver = {
+		.name = "hdmi-i2s-codec",
+		.owner = THIS_MODULE,
+	},
+	.probe = hdmi_i2s_probe,
+	.remove = __devexit_p(hdmi_i2s_remove),
+};
+
+module_platform_driver(codec_hdmi_i2s_driver);
+
+MODULE_LICENSE("GPL");
+MODULE_DESCRIPTION("ALSA Codec Driver for HDMI I2S");
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/sound/soc/celestial/Makefile linux-linaro-3.4-2012.05-1_cavium/sound/soc/celestial/Makefile
--- linux-linaro-3.4-2012.05-1_original/sound/soc/celestial/Makefile	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/sound/soc/celestial/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1 @@
+obj-y := cnc-machine.o platform-i2s.o codec-hdmi-i2s.o
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/sound/soc/celestial/platform-i2s.c linux-linaro-3.4-2012.05-1_cavium/sound/soc/celestial/platform-i2s.c
--- linux-linaro-3.4-2012.05-1_original/sound/soc/celestial/platform-i2s.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/sound/soc/celestial/platform-i2s.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,380 @@
+#include <linux/module.h>
+#include <linux/dma-mapping.h>
+#include <linux/slab.h>
+#include <linux/io.h>
+
+#include <sound/soc.h>
+#include <sound/tlv.h>
+
+#define AUDIO_I2S0_SHIFT 0x0000
+#define AUDIO_I2S0_CNTL  0x0004
+#define AUDIO_I2S0_RP0   0x0100
+#define AUDIO_I2S0_WP0   0x0104
+#define AUDIO_I2S0_UP0   0x0108
+#define AUDIO_I2S0_LOW0  0x010c
+#define AUDIO_I2S0_SCAL0 0x0110
+#define AUDIO_I2S0_RP1   0x0114
+#define AUDIO_I2S0_WP1   0x0118
+#define AUDIO_I2S0_UP1   0x011c
+#define AUDIO_I2S0_LOW1  0x0120
+#define AUDIO_I2S0_SCAL1 0x0124
+
+#define AUDIO_I2S_TOGGLE 0x80000000
+#define AUDIO_I2S_BYTES  0x7FFFFFF8
+#define AUDIO_I2S_SCAL_MAX 0x01000000
+
+#include <mach/cnc1900_power_clk.h>
+
+struct cnc_snd_data {
+	void __iomem *mmio;
+	size_t size;
+
+	struct timer_list timer;
+};
+
+static const DECLARE_TLV_DB_LINEAR(volume_tlv, 0, 100);
+
+static int cnc_i2s_get_value(struct snd_kcontrol *kcontrol, struct snd_ctl_elem_value *ucontrol)
+{
+	struct snd_soc_dai *dai = snd_kcontrol_chip(kcontrol);
+	struct cnc_snd_data *data = snd_soc_platform_get_drvdata(dai->card->rtd->platform);
+	struct soc_mixer_control *mc = (struct soc_mixer_control *)kcontrol->private_value;
+	unsigned int val;
+
+	val = __raw_readl(data->mmio + mc->reg);
+	ucontrol->value.integer.value[0] = val / (AUDIO_I2S_SCAL_MAX / 100);
+	return 0;
+}
+
+static int cnc_i2s_set_value(struct snd_kcontrol *kcontrol, struct snd_ctl_elem_value *ucontrol)
+{
+	struct snd_soc_dai *dai = snd_kcontrol_chip(kcontrol);
+	struct cnc_snd_data *data = snd_soc_platform_get_drvdata(dai->card->rtd->platform);
+	struct soc_mixer_control *mc = (struct soc_mixer_control *)kcontrol->private_value;
+	unsigned int val;
+
+	val = ucontrol->value.integer.value[0] * (AUDIO_I2S_SCAL_MAX / 100);
+	__raw_writel(val, data->mmio + mc->reg);
+	return 1;
+}
+
+static const struct snd_kcontrol_new cnc_i2s_hw_controls[] = {
+	SOC_SINGLE_EXT_TLV("I2S Volume", AUDIO_I2S0_SCAL0, 0, 100, 0,
+		cnc_i2s_get_value, cnc_i2s_set_value, volume_tlv),
+};
+
+static int cnc_dai_probe(struct snd_soc_dai *dai)
+{
+	return snd_soc_add_dai_controls(dai, cnc_i2s_hw_controls,
+		ARRAY_SIZE(cnc_i2s_hw_controls));
+}
+
+static int cnc_i2s_hw_params(struct snd_pcm_substream *substream,
+				 struct snd_pcm_hw_params *params, struct snd_soc_dai *dai)
+{
+	struct snd_soc_pcm_runtime *rtd = substream->private_data;
+	//struct cnc_snd_data *data = snd_soc_platform_get_drvdata(rtd->platform);
+	int rate = params_rate(params);
+
+extern void clock_alsa_setclock(int rate);
+	clock_alsa_setclock(rate);
+	return 0;
+}
+
+static int cnc_i2s_trigger(struct snd_pcm_substream *substream, int cmd,
+				struct snd_soc_dai *dai)
+{
+	struct snd_pcm_runtime *run = substream->runtime;
+	struct snd_soc_pcm_runtime *rtd = substream->private_data;
+	struct cnc_snd_data *data = snd_soc_platform_get_drvdata(rtd->platform);
+	unsigned int scale = __raw_readl(data->mmio + AUDIO_I2S0_SCAL0);
+	int shift = 32 - snd_pcm_format_width(run->format);
+
+	if (strstr(dai->card->name, "HDMI"))
+		shift = 1;
+
+	switch (cmd) {
+	case SNDRV_PCM_TRIGGER_START:
+	case SNDRV_PCM_TRIGGER_RESUME:
+		if (!scale)
+			__raw_writel(0x01000000, data->mmio + AUDIO_I2S0_SCAL0);
+
+		__raw_writel(shift, data->mmio + AUDIO_I2S0_SHIFT);
+		__raw_writel(0x0100, data->mmio + AUDIO_I2S0_CNTL);
+		break;
+	case SNDRV_PCM_TRIGGER_STOP:
+	case SNDRV_PCM_TRIGGER_SUSPEND:
+		__raw_writel(0x0000, data->mmio + AUDIO_I2S0_CNTL);
+		break;
+	}
+	return 0;
+}
+
+static void cnc_i2s_timer_func(unsigned long timer_data)
+{
+	struct snd_pcm_substream *substream = (struct snd_pcm_substream *)timer_data;
+	struct snd_pcm_runtime *run = substream->runtime;
+	struct snd_soc_pcm_runtime *rtd = substream->private_data;
+	struct cnc_snd_data *data = snd_soc_platform_get_drvdata(rtd->platform);
+	int ms = 1000 * run->control->avail_min / run->rate;
+
+	snd_pcm_period_elapsed(substream);
+	mod_timer(&data->timer, jiffies + msecs_to_jiffies(ms));
+}
+
+static int cnc_i2s_prepare(struct snd_pcm_substream *substream,
+				struct snd_soc_dai *dai)
+{
+	struct snd_soc_pcm_runtime *rtd = substream->private_data;
+	struct cnc_snd_data *data = snd_soc_platform_get_drvdata(rtd->platform);
+
+	init_timer(&data->timer);
+	data->timer.function = cnc_i2s_timer_func;
+	data->timer.data = (unsigned long)substream;
+
+	data->timer.function(data->timer.data);
+	return 0;
+}
+
+static void cnc_i2s_shutdown(struct snd_pcm_substream *substream,
+				struct snd_soc_dai *dai)
+{
+	struct snd_soc_pcm_runtime *rtd = substream->private_data;
+	struct cnc_snd_data *data = snd_soc_platform_get_drvdata(rtd->platform);
+
+	del_timer(&data->timer);
+}
+
+static struct snd_soc_dai_ops dai_i2s_ops = {
+	.hw_params = cnc_i2s_hw_params,
+	.trigger = cnc_i2s_trigger,
+	.prepare = cnc_i2s_prepare,
+	.shutdown = cnc_i2s_shutdown,
+};
+
+static struct snd_soc_dai_driver snd_soc_i2s_dai = {
+	.name  = "cnc-pcm-i2s",
+	.playback = {
+		.rates   = SNDRV_PCM_RATE_CONTINUOUS,
+		.formats = SNDRV_PCM_FMTBIT_S16 | SNDRV_PCM_FMTBIT_S24_3LE,
+		.channels_min = 1,
+		.channels_max = 8,
+	},
+	.ops = &dai_i2s_ops,
+	.probe = cnc_dai_probe,
+};
+
+static const struct snd_pcm_hardware cnc_pcm_hardware = {
+	.info = SNDRV_PCM_INFO_INTERLEAVED | SNDRV_PCM_INFO_RESUME,
+	.formats = SNDRV_PCM_FMTBIT_S16 | SNDRV_PCM_FMTBIT_S24_3LE,
+	.periods_min = 2,
+	.periods_max = 32,
+	.period_bytes_min = 8,
+	.period_bytes_max = SZ_16K,
+	.buffer_bytes_max = SZ_32K,
+};
+
+static int cnc_pcm_open(struct snd_pcm_substream *substream)
+{
+	return snd_soc_set_runtime_hwparams(substream, &cnc_pcm_hardware);
+}
+
+static inline snd_pcm_sframes_t dmabytes_to_frames(ssize_t size)
+{
+	return size >> 3;
+}
+
+static inline ssize_t frames_to_dmabytes(snd_pcm_sframes_t size)
+{
+	return size << 3;
+}
+
+static int cnc_pcm_hw_params(struct snd_pcm_substream *substream,
+				 struct snd_pcm_hw_params *params)
+{
+	struct snd_soc_pcm_runtime *rtd = substream->private_data;
+	struct cnc_snd_data *data = snd_soc_platform_get_drvdata(rtd->platform);
+
+	// 32 BITS 2 CHANNELS
+	data->size = frames_to_dmabytes(params_buffer_size(params));
+	return snd_pcm_lib_malloc_pages(substream, data->size);
+}
+
+static int cnc_pcm_hw_free(struct snd_pcm_substream *substream)
+{
+	return snd_pcm_lib_free_pages(substream);
+}
+
+static int cnc_pcm_prepare(struct snd_pcm_substream *substream)
+{
+	struct snd_pcm_runtime *run = substream->runtime;
+	struct snd_soc_pcm_runtime *rtd = substream->private_data;
+	struct cnc_snd_data *data = snd_soc_platform_get_drvdata(rtd->platform);
+
+	__raw_writel(run->dma_addr, data->mmio + AUDIO_I2S0_RP0);
+	__raw_writel(run->dma_addr, data->mmio + AUDIO_I2S0_WP0);
+	__raw_writel(run->dma_addr, data->mmio + AUDIO_I2S0_LOW0);
+	__raw_writel(run->dma_addr + data->size, data->mmio + AUDIO_I2S0_UP0);
+	return 0;
+}
+
+static snd_pcm_uframes_t cnc_pcm_pointer(struct snd_pcm_substream *substream)
+{
+	struct snd_soc_pcm_runtime *rtd = substream->private_data;
+	struct cnc_snd_data *data = snd_soc_platform_get_drvdata(rtd->platform);
+	unsigned int rptr;
+
+	rptr = (__raw_readl(data->mmio + AUDIO_I2S0_RP0) & AUDIO_I2S_BYTES)
+			- __raw_readl(data->mmio + AUDIO_I2S0_LOW0);
+
+	return dmabytes_to_frames(rptr);
+}
+
+static void cnc_update_wrptr(struct snd_pcm_substream *substream, int pos)
+{
+	struct snd_soc_pcm_runtime *rtd = substream->private_data;
+	struct cnc_snd_data *data = snd_soc_platform_get_drvdata(rtd->platform);
+	unsigned int wptr;
+
+	wptr = __raw_readl(data->mmio + AUDIO_I2S0_LOW0) + frames_to_dmabytes(pos);
+	if (wptr > data->size)
+		wptr = (wptr - data->size) | AUDIO_I2S_TOGGLE;
+
+	__raw_writel(wptr, data->mmio + AUDIO_I2S0_WP0);
+}
+
+static unsigned char buf[SZ_256K] = { 0 };
+
+static int cnc_pcm_copy(struct snd_pcm_substream *substream, int channel,
+			     snd_pcm_uframes_t pos, void __user *src, snd_pcm_uframes_t count)
+{
+	struct snd_pcm_runtime *run = substream->runtime;
+	unsigned char *wptr = run->dma_area + frames_to_dmabytes(pos);
+	int zero_bytes = 4 - snd_pcm_format_width(run->format) / 8;
+	int i, j, k;
+
+	if (copy_from_user(buf, src, frames_to_bytes(run, count)))
+		return -EFAULT;
+
+	for (i = 0, k = 0; i < count << 1; i++) {
+		if (i % 2) {
+			if (run->channels > 1)
+				k += (4 - zero_bytes) * (run->channels - 2);
+			else
+				k -= (4 - zero_bytes);
+		}
+
+		for (j = 0; j < zero_bytes; j++)
+			*wptr++ = 0;
+		for (j = zero_bytes; j < 4; j++)
+			*wptr++ = buf[k++];
+	}
+
+	dsb();
+	cnc_update_wrptr(substream, pos + count);
+	return count;
+}
+
+static int cnc_pcm_silence(struct snd_pcm_substream *substream, int channel,
+			     snd_pcm_uframes_t pos, snd_pcm_uframes_t count)
+{
+	struct snd_pcm_runtime *run = substream->runtime;
+	unsigned char *wptr = run->dma_area + frames_to_dmabytes(pos);
+	int i, j;
+
+	for (i = 0; i < count << 1; i++) {
+		for (j = 0; j < 4; j++)
+			*wptr++ = 0;
+	}
+
+	dsb();
+	cnc_update_wrptr(substream, pos + count);
+	return count;	
+}
+
+static struct snd_pcm_ops pcm_i2s_ops = {
+	.open  = cnc_pcm_open,
+	.hw_params = cnc_pcm_hw_params,
+	.hw_free = cnc_pcm_hw_free,
+	.prepare = cnc_pcm_prepare,
+	.pointer = cnc_pcm_pointer,
+	.copy = cnc_pcm_copy,
+	.silence = cnc_pcm_silence,
+	.ioctl = snd_pcm_lib_ioctl,
+};
+
+static u64 dma_mask = DMA_BIT_MASK(32);
+
+static int cnc_pcm_new(struct snd_soc_pcm_runtime *rtd)
+{
+	struct snd_card *card = rtd->card->snd_card;
+	struct snd_pcm *pcm = rtd->pcm;
+
+	if (!card->dev->dma_mask)
+		card->dev->dma_mask = &dma_mask;
+	if (!card->dev->coherent_dma_mask)
+		card->dev->coherent_dma_mask = DMA_BIT_MASK(32);
+
+	snd_pcm_lib_preallocate_pages_for_all(pcm, SNDRV_DMA_TYPE_DEV,
+		card->dev, SZ_256K, SZ_256K);
+	return 0;
+}
+
+static void cnc_pcm_free(struct snd_pcm *pcm)
+{
+	snd_pcm_lib_preallocate_free_for_all(pcm);
+}
+
+static struct snd_soc_platform_driver snd_soc_i2s_platform = {
+	.ops		= &pcm_i2s_ops,
+	.pcm_new	= cnc_pcm_new,
+	.pcm_free	= cnc_pcm_free,
+};
+
+static int __devinit snd_platform_i2s_probe(struct platform_device *pdev)
+{
+	struct cnc_snd_data *data;
+	struct resource *iores;
+
+	clock_audio_enaclock(_clock_enable);
+	clock_audiopll_enaclock(_clock_enable);
+
+	data = kzalloc(sizeof(struct cnc_snd_data), GFP_KERNEL);
+	if (!data)
+		return -ENOMEM;
+
+	iores = platform_get_resource(pdev, IORESOURCE_MEM, 0);
+	if (!iores)
+		return -ENODEV;
+
+	data->mmio = ioremap(iores->start, resource_size(iores));
+	if (!data->mmio)
+		return -EBUSY;
+
+	platform_set_drvdata(pdev, data);
+
+	snd_soc_register_platform(&pdev->dev, &snd_soc_i2s_platform);
+	snd_soc_register_dai(&pdev->dev, &snd_soc_i2s_dai);
+	return 0;
+}
+
+static int __devexit snd_platform_i2s_remove(struct platform_device *pdev)
+{
+	snd_soc_unregister_dai(&pdev->dev);
+	snd_soc_unregister_platform(&pdev->dev);
+	return 0;
+}
+
+static struct platform_driver snd_platform_i2s_driver = {
+	.driver	= {
+		.name  = "cnc-pcm-i2s",
+		.owner = THIS_MODULE,
+	},
+	.probe	= snd_platform_i2s_probe,
+	.remove	= __devexit_p(snd_platform_i2s_remove),
+};
+
+module_platform_driver(snd_platform_i2s_driver);
+
+MODULE_LICENSE("GPL");
+MODULE_DESCRIPTION("ALSA Platfrom Driver for DMA & I2S");
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/sound/soc/Makefile linux-linaro-3.4-2012.05-1_cavium/sound/soc/Makefile
--- linux-linaro-3.4-2012.05-1_original/sound/soc/Makefile	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/sound/soc/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -25,3 +25,4 @@
 obj-$(CONFIG_SND_SOC)	+= sh/
 obj-$(CONFIG_SND_SOC)	+= tegra/
 obj-$(CONFIG_SND_SOC)	+= txx9/
+obj-$(CONFIG_SND_SOC)	+= celestial/
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/tests/Makefile linux-linaro-3.4-2012.05-1_cavium/tests/Makefile
--- linux-linaro-3.4-2012.05-1_original/tests/Makefile	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/tests/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,12 @@
+src_files := $(shell ls *.c)
+elf_files := $(strip $(patsubst %.c, test.%, $(src_files)))
+
+all: $(elf_files)
+
+CFLAGS := -I$(shell pwd)/../include -D__EXPORTED_HEADERS__
+
+$(elf_files): test.%: %.c
+	$(CROSS_COMPILE)gcc $(CFLAGS) $< -o $@
+
+clean:
+	rm -f $(elf_files)
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/tests/mtd.c linux-linaro-3.4-2012.05-1_cavium/tests/mtd.c
--- linux-linaro-3.4-2012.05-1_original/tests/mtd.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/tests/mtd.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,120 @@
+#include <stdio.h>
+#include <unistd.h>
+#include <stdlib.h>
+#include <errno.h>
+
+#include <fcntl.h>
+#include <sys/types.h>
+#include <sys/ioctl.h>
+#include <sys/stat.h>
+
+#include <mtd/mtd-abi.h>
+
+static int mtd_read(int fd, int from, int len)
+{
+	int rdlen = ((len + 7) / 8) * 8;
+	char *buf = calloc(1, rdlen);
+	int ret = lseek(fd, from, SEEK_SET);
+
+	if (ret == from && buf) {
+		ret = read(fd, buf, rdlen);
+		if (ret == rdlen) {
+			int i = 0;
+			for (; i < rdlen / 8; i++)
+				printf("%02x %02x %02x %02x %02x %02x %02x %02x\n",
+					buf[i * 8 + 0], buf[i * 8 + 1], buf[i * 8 + 2], buf[i * 8 + 3],
+					buf[i * 8 + 4], buf[i * 8 + 5], buf[i * 8 + 6], buf[i * 8 + 7]);
+		}
+	}
+	return 0;
+}
+
+static int mtd_write(int fd, int from, int len)
+{
+	char *buf = calloc(1, len);
+	int ret = lseek(fd, from, SEEK_SET);
+
+	if (ret == from && buf) {
+		int i = 0;
+		for (; i < len; i++)
+			buf[i] = i;
+
+		ret = write(fd, buf, len);
+		if (ret == len)
+			printf("Write @%x[%d] done.\n", from, len);
+	}
+	return 0;
+}
+
+static int mtd_erase(int fd, int from, int len)
+{
+	struct erase_info_user cmd = { from, len };
+	int ret = ioctl(fd, MEMERASE, &cmd);
+	if (ret == 0)
+		printf("Erase @%x[%d] done.\n", from, len);
+	return 0;
+}
+
+int main(int argc, char **argv)
+{
+	int from = 0, len = 0, fd, c;
+	int ret = 0;
+	char ops = 0;
+	char *mtd;
+
+	while ((c = getopt(argc, argv, "rwef:l:")) != -1) {
+		switch (c) {
+			case 'r': 
+			case 'w': 
+			case 'e': 
+				ops = c;
+				mtd = optarg;
+				break;
+			case 'f':
+				from = strtol(optarg, NULL, 0);
+				break;
+			case 'l':
+				len  = strtol(optarg, NULL, 0);
+				break;
+			default:
+				ret = -EINVAL;
+				break;
+		}
+	}
+
+	if (optind < argc)
+		mtd = argv[optind];
+	else
+		ret = -EINVAL;
+
+	if (ret < 0)
+		goto usage;
+
+	fd = open(mtd, O_RDWR);
+	if (fd < 0) {
+		printf("Open %s ERROR!\n", mtd);
+		return -ENODEV;
+	}
+
+	switch (ops) {
+		case 'r':
+			ret = mtd_read (fd, from, len);
+			break;
+		case 'w':
+			ret = mtd_write(fd, from, len);
+			break;
+		case 'e':
+			ret = mtd_erase(fd, from, len);
+			break;
+		default:
+			ret = -EINVAL;
+			break;
+	}
+
+	return 0;
+
+usage:
+	printf("Usage: test.mtd -r|w|e [-f <from>] [-l <len>] /dev/mtdN\n");
+	printf("       Test SPI & NAND Flash\n");
+	return ret;
+}
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/tests/tty.c linux-linaro-3.4-2012.05-1_cavium/tests/tty.c
--- linux-linaro-3.4-2012.05-1_original/tests/tty.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/tests/tty.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,67 @@
+#include <stdio.h>
+#include <unistd.h>
+#include <stdlib.h>
+#include <errno.h>
+
+#include <fcntl.h>
+#include <termios.h>
+
+tcflag_t rate_map[][2] = {
+	{ 9600,   B9600 },
+	{ 115200, B115200 },
+};
+
+int main(int argc, char **argv)
+{
+	int rate = 115200, fd, c;
+	int ret = 0, i;
+	struct termios ios;
+	tcflag_t flag = 0;
+	char *tty;
+
+	while ((c = getopt(argc, argv, "as:")) != -1) {
+		switch (c) {
+			case 'a': 
+				flag = CRTSCTS;
+				break;
+			case 's': 
+				rate = strtol(optarg, NULL, 0);
+				break;
+			default:
+				ret = -EINVAL;
+				break;
+		}
+	}
+	
+	if (optind < argc)
+		tty = argv[optind];
+	else
+		ret = -EINVAL;
+
+	if (ret < 0)
+		goto usage;
+
+	fd = open(tty, O_RDWR|O_NOCTTY);
+	if (fd < 0) {
+		printf("Open %s ERROR!\n", tty);
+		return -ENODEV;
+	}
+
+	for (i = 0; i < sizeof(rate_map)/sizeof(tcflag_t)/2; i++) {
+		if (rate_map[i][0] == rate)
+			flag |= rate_map[i][1];
+	}
+
+	tcgetattr(fd, &ios);
+	ios.c_cflag &= ~(CBAUD | CRTSCTS);
+	ios.c_cflag |= flag;
+	tcsetattr(fd, TCSANOW, &ios);
+
+	printf("Set Termios %x\n", flag);
+	return 0;
+
+usage:
+	printf("Usage: test.tty [-a] [-s <rate>] /dev/ttySN\n");
+	printf("       Test ttyS Console\n");
+	return ret;
+}
